/**
 * Copyright 2012 Peergreen S.A.S.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

package org.ow2.util.osgi.toolkit.filter;

/**
* A {@code Filter} is ...
*
* @author Guillaume Sauthier
*/
class Filter extends AbstractFilter {
    private final String expression;

    public Filter(final String expression) {

        assert expression != null;

        String trimmed = expression.trim();
        if (trimmed.charAt(0) == '(' && trimmed.charAt(trimmed.length() - 1) == ')') {
            // Strip first char
            trimmed = trimmed.substring(1);
            // Strip last char
            trimmed = trimmed.substring(0, trimmed.length() - 1);
        }

        this.expression = trimmed;
    }

    public Filter(String name, Operand equal, String value) {
        this(name + equal.getText() + value);
    }

    public String asText() {
        return "(" + expression + ")";
    }
}
